//
// GetOpenDirectoryName.cpp
//
// Written by Nobuki HIRAMINE
// Last modified : 2007/04/14
//
#include "stdafx.h"
#include <shlobj.h>

static
int CALLBACK SHBrowseProc(HWND hWnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
    if( uMsg == BFFM_INITIALIZED && lpData )
    {
        //  ftHgőIpX̎w
        SendMessage( hWnd, BFFM_SETSELECTION, TRUE, lpData);
    }
    return 0;
}

static
void SHFree(ITEMIDLIST* pidl)
{
    IMalloc*  pMalloc;
    SHGetMalloc( &pMalloc );
    if ( pMalloc )
    {
        pMalloc->Free( pidl );
        pMalloc->Release();
    }
}

BOOL GetOpenDirectoryName( HWND hwndOwner, LPCTSTR lpszDefaultFolder, LPTSTR lpszBuffer, DWORD dwBufferSize )
{
	BROWSEINFO  bi;
	ZeroMemory( &bi, sizeof( BROWSEINFO ));
	bi.hwndOwner	= hwndOwner;
	bi.lpfn			= SHBrowseProc;	//  R[obN֐w
	bi.lParam		= (LPARAM)lpszDefaultFolder;	//  ftHgőIĂtH_w
	bi.lpszTitle	= _T("tH_IĂ");	//  ^Cg̎w

	ITEMIDLIST*  pidl = SHBrowseForFolder( &bi );	//  tH__CAŐN
	if( pidl )
	{
		//  IꂽtH_擾
		TCHAR  szSelectedFolder[_MAX_PATH];
		SHGetPathFromIDList( pidl, szSelectedFolder );
		SHFree(pidl);
		if( (DWORD)_tcslen(szSelectedFolder) < dwBufferSize )
		{
			_tcsncpy_s( lpszBuffer, dwBufferSize, szSelectedFolder, _TRUNCATE );
			//  tH_Iꂽ
			return TRUE;
		}
	}
	//  tH_͑IȂ
	return FALSE;
}

